## pillow 5.1.0

=== Makefile ===
# https://www.gnu.org/software/make/manual/html_node/Phony-Targets.html
.PHONY: clean coverage doc docserve help inplace install install-req release-test sdist test upload upload-test
.DEFAULT_GOAL := release-test

clean:
	python setup.py clean
	rm src/PIL/*.so || true
	rm -r build || true
	find . -name __pycache__ | xargs rm -r || true

BRANCHES=`git branch -a | grep -v HEAD | grep -v master | grep remote`
co:
	-for i in $(BRANCHES) ; do \
        git checkout -t $$i ; \
    done

coverage:
	python selftest.py
	python setup.py test
	rm -r htmlcov || true
	coverage report

doc:
	$(MAKE) -C docs html

doccheck:
	$(MAKE) -C docs html
# Don't make our tests rely on the links in the docs being up every single build.
# We don't control them.  But do check, and update them to the target of their redirects.
	$(MAKE) -C docs linkcheck || true

docserve:
	cd docs/_build/html && python -mSimpleHTTPServer 2> /dev/null&

help:
	@echo "Welcome to Pillow development. Please use \`make <target>\` where <target> is one of"
	@echo "  clean              remove build products"
	@echo "  coverage           run coverage test (in progress)"
	@echo "  doc                make html docs"
	@echo "  docserve           run an http server on the docs directory"
	@echo "  html               to make standalone HTML files"
	@echo "  inplace            make inplace extension"
	@echo "  install            make and install"
	@echo "  install-coverage   make and install with C coverage"
	@echo "  install-req        install documentation and test dependencies"
	@echo "  install-venv       install in virtualenv"
	@echo "  release-test       run code and package tests before release"
	@echo "  test               run tests on installed pillow"
	@echo "  upload             build and upload sdists to PyPI"
	@echo "  upload-test        build and upload sdists to test.pythonpackages.com"

inplace: clean
	python setup.py develop build_ext --inplace

install:
	python setup.py install
	python selftest.py

install-coverage:
	CFLAGS="-coverage" python setup.py build_ext install
	python selftest.py

debug:
# make a debug version if we don't have a -dbg python. Leaves in symbols
# for our stuff, kills optimization, and redirects to dev null so we
# see any build failures.
	make clean > /dev/null
	CFLAGS='-g -O0' python setup.py build_ext install > /dev/null

install-req:
	pip install -r requirements.txt

install-venv:
	virtualenv .
	bin/pip install -r requirements.txt

release-test:
	$(MAKE) install-req
	python setup.py develop
	python selftest.py
	python -m pytest Tests
	python setup.py install
	python -m pytest -qq
	check-manifest
	pyroma .
	viewdoc

sdist:
	python setup.py sdist --format=gztar

test:
	pytest -qq

# https://docs.python.org/2/distutils/packageindex.html#the-pypirc-file
upload-test:
#       [test]
#       username:
#       password:
#       repository = http://test.pythonpackages.com
	python setup.py sdist --format=gztar upload -r test

upload:
	python setup.py sdist --format=gztar upload

readme:
	viewdoc

=== debian/changelog ===
pillow (5.1.0-1ubuntu0.8) bionic-security; urgency=medium

  * SECURITY UPDATE: incomplete fix for CVE-2022-22817
    - debian/patches/CVE-2022-22817-2.patch: restrict builtins within
      lambdas for ImageMath.eval in Tests/test_imagemath.py,
      src/PIL/ImageMath.py.
    - CVE-2022-22817

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 20 Oct 2022 11:32:25 -0400

pillow (5.1.0-1ubuntu0.7) bionic-security; urgency=medium

  * SECURITY UPDATE: regular expression DoS
    - debian/patches/CVE-2021-23437.patch: raise ValueError if color
      specifier is too long in Tests/test_imagecolor.py,
      src/PIL/ImageColor.py.
    - CVE-2021-23437
  * SECURITY UPDATE: Dos via buffer overflow
    - debian/patches/CVE-2021-34552.patch: limit sprintf modes to 10
      characters in src/libImaging/Convert.c.
    - CVE-2021-34552
  * SECURITY UPDATE: improper initialization
    - debian/patches/CVE-2022-22815.patch: initialize coordinates to zero
      in src/path.c.
    - CVE-2022-22815
  * SECURITY UPDATE: buffer over-read during initialization
    - debian/patches/CVE-2022-22816.patch: handle case where path count is
      zero in src/path.c.
    - CVE-2022-22816
  * SECURITY UPDATE: evaluation of arbitrary expressions
    - debian/patches/CVE-2022-22817.patch: restrict builtins for
      ImageMath.eval in Tests/test_imagemath.py, src/PIL/ImageMath.py.
    - CVE-2022-22817

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 12 Jan 2022 13:21:48 -0500

pillow (5.1.0-1ubuntu0.6) bionic-security; urgency=medium

  * SECURITY UPDATE: OOB read in Jpeg2KDecode
    - debian/patches/CVE-2021-25287_8.patch: handle different widths for
      each band in src/libImaging/Jpeg2KDecode.c.
    - CVE-2021-25287
    - CVE-2021-25288
  * SECURITY UPDATE: DOS in PsdImagePlugin
    - debian/patches/CVE-2021-28675.patch: sanity check the number of
      input layers in Tests/test_decompression_bomb.py,
      Tests/test_file_apng.py, Tests/test_file_blp.py,
      Tests/test_file_tiff.py, src/PIL/ImageFile.py,
      src/PIL/PsdImagePlugin.py.
    - CVE-2021-28675
  * SECURITY UPDATE: FLI DOS
    - debian/patches/CVE-2021-28676.patch: check the block advance in
      src/libImaging/FliDecode.c.
    - CVE-2021-28676
  * SECURITY UPDATE: EPS DOS on _open
    - debian/patches/CVE-2021-28677.patch: properly handle line endings in
      src/PIL/EpsImagePlugin.py.
    - CVE-2021-28677
  * SECURITY UPDATE: BLP DOS
    - debian/patches/CVE-2021-28678.patch: check that reads return data in
      src/PIL/BlpImagePlugin.py.
    - CVE-2021-28678

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 18 May 2021 07:33:36 -0400

pillow (5.1.0-1ubuntu0.5) bionic-security; urgency=medium

  * SECURITY UPDATE: negative-offset memcpy with an invalid size
    - debian/patches/CVE-2021-25290.patch: add extra check to
      src/libImaging/TiffDecode.c.
    - CVE-2021-25290
  * SECURITY UPDATE: DoS via backtrack regex
    - debian/patches/CVE-2021-25292.patch: use more specific regex in
      src/PIL/PdfParser.py.
    - CVE-2021-25292
  * SECURITY UPDATE: Out of Bounds Read
    - debian/patches/CVE-2021-25293.patch: add more checks to
      src/libImaging/SgiRleDecode.c.
    - CVE-2021-25293
  * SECURITY UPDATE: DoS via invalid reported size
    - debian/patches/CVE-2021-2792x.patch: check reported sizes in
      src/PIL/BlpImagePlugin.py, src/PIL/IcnsImagePlugin.py,
      src/PIL/IcoImagePlugin.py.
    - CVE-2021-27921
    - CVE-2021-27922
    - CVE-2021-27923

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 10 Mar 2021 13:01:32 -0500

pillow (5.1.0-1ubuntu0.4) bionic-security; urgency=medium

  * SECURITY UPDATE: buffer over-read via PCX file
    - debian/patches/CVE-2020-35653.patch: don't trust the image to specify
      a buffer size in src/PIL/PcxImagePlugin.py.
    - CVE-2020-35653
  * SECURITY UPDATE: buffer over-read via SGI RLE image file
    - debian/patches/CVE-2020-35655-1.patch: add checks to
      src/libImaging/SgiRleDecode.c.
    - debian/patches/CVE-2020-35655-2.patch: rework error flags in
      src/libImaging/SgiRleDecode.c.
    - CVE-2020-35655

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 13 Jan 2021 10:51:02 -0500

pillow (5.1.0-1ubuntu0.3) bionic-security; urgency=medium

  * SECURITY UPDATE: multiple out of bounds reads
    - debian/patches/CVE-2020-10177-1.patch: fix issue in
      src/libImaging/FliDecode.c.
    - debian/patches/CVE-2020-10177-2.patch: refactor to macro in
      src/libImaging/FliDecode.c.
    - debian/patches/CVE-2020-10177-3.patch: fix OOB Reads in SS2 Chunk in
      src/libImaging/FliDecode.c.
    - debian/patches/CVE-2020-10177-4.patch: fix OOB in LC packet in
      src/libImaging/FliDecode.c.
    - debian/patches/CVE-2020-10177-5.patch: fix OOB Advance Values in
      src/libImaging/FliDecode.c.
    - debian/patches/CVE-2020-10177-6.patch: fix OOB Read in FLI Copy Chunk
      in src/libImaging/FliDecode.c.
    - debian/patches/CVE-2020-10177-7.patch: fix comments in
      src/libImaging/FliDecode.c.
    - debian/patches/CVE-2020-10177-8.patch: additional FLI check in
      src/libImaging/FliDecode.c.
    - CVE-2020-10177
  * SECURITY UPDATE: out of bounds read with PCX files
    - debian/patches/CVE-2020-10378.patch: fix OOB Access in
      src/libImaging/PcxDecode.c.
    - CVE-2020-10378
  * SECURITY UPDATE: out-of-bounds read via JP2 file
    - debian/patches/CVE-2020-10994-1.patch: fix for OOB Read in
      src/libImaging/Jpeg2KDecode.c.
    - debian/patches/CVE-2020-10994-2.patch: fix typo in
      src/libImaging/Jpeg2KDecode.c.
    - CVE-2020-10994
  * SECURITY UPDATE: out-of-bounds read via SGI file
    - debian/patches/CVE-2020-11538.patch: track number of pixels, not the
      number of runs in src/libImaging/SgiRleDecode.c.
    - CVE-2020-11538

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 07 Jul 2020 13:35:30 -0400

pillow (5.1.0-1ubuntu0.2) bionic-security; urgency=medium



=== debian/control ===
Source: pillow
Section: python
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Matthias Klose <doko@debian.org>
Build-Depends: debhelper (>= 9), tk-dev, dpkg-dev (>= 1.16.1~),
  dh-python,
  python2.7-dev (>= 2.7.8-4),
  python-all-dev, python-all-dbg, python-setuptools,
  python3-all-dev, python3-all-dbg, python3-setuptools,
  python-tk, python-tk-dbg,
  python3-tk, python3-tk-dbg,
  python-pytest, python3-pytest,
  python-olefile, python3-olefile,
  libfreetype6-dev, libjpeg-dev, zlib1g-dev, liblcms2-dev,
  libtiff5-dev | libtiff-dev, libwebp-dev, libraqm-dev,
Build-Depends-Indep: python3-sphinx, python3-sphinx-rtd-theme,
Build-Conflicts: python-cffi, python3-cffi
Standards-Version: 4.1.4
Homepage: http://python-pillow.github.io/
XS-Testsuite: autopkgtest

Package: python-pil
Architecture: any
Multi-Arch: same
Depends: ${python:Depends}, mime-support | python-pil.imagetk,
  ${shlibs:Depends}, ${misc:Depends}
Recommends: python-olefile
Suggests: python-pil-doc, python-pil-dbg
Provides: ${python:Provides}, python-pillow
Breaks: python-imaging (<< 1.1.7+2.0.0-1.1),
  rapid-photo-downloader (<< 0.4.11), 
  tilestache (<< 1.49.8-3),
Replaces: python-imaging (<< 1.1.7+2.0.0-1.1)
Description: Python Imaging Library (Pillow fork)
 The Python Imaging Library (PIL) adds an image object to your Python
 interpreter. You can load images from a variety of file formats, and
 apply a rich set of image operations to them.
 .
 Image Objects:
  o Bilevel, greyscale, palette, true colour (RGB), true colour with
    transparency (RGBA).
  o colour separation (CMYK).
  o Copy, cut, paste operations.
  o Flip, transpose, resize, rotate, and arbitrary affine transforms.
  o Transparency operations.
  o Channel and point operations.
  o Colour transforms, including matrix operations.
  o Image enhancement, including convolution filters.
 .
 File Formats:
  o Full (Open/Load/Save): BMP, EPS (with ghostscript), GIF, IM, JPEG,
    MSP, PDF, PNG, PPM, TIFF, XBM.
  o Read only (Open/Load): ARG, CUR, DCX, FLI, FPX, GBR, GD, ICO, IMT, IPTC,
    MCIDAS, MPEG, PhotoCD, PCX, PIXAR, PSD, TGA, SGI, SUN, TGA, WMF, XPM.
  o Save only: PDF, EPS (without ghostscript).

Package: python-pil-dbg
Section: debug
Priority: optional
Architecture: any
Multi-Arch: same
Depends: python-pil (= ${binary:Version}), python-dbg,
  ${shlibs:Depends}, ${misc:Depends}
Provides: python-imaging-dbg
Breaks: python-imaging-dbg (<< 1.1.7+2.0.0-1.1)
Replaces: python-imaging-dbg (<< 1.1.7+2.0.0-1.1)
Description: Python Imaging Library (debug extension)
 The Python Imaging Library (PIL) adds an image object to your Python
 interpreter. You can load images from a variety of file formats, and
 apply a rich set of image operations to them.
 .
 This package contains the extension built for the Python debug interpreter.

Package: python-pil.imagetk
Architecture: any
Multi-Arch: same
Depends: python-pil (= ${binary:Version}), python-tk (>= 2.7.7-2),
  ${python:Depends}, ${shlibs:Depends}, ${misc:Depends}
Suggests: python-pil-doc, python-pil.imagetk-dbg
Provides: ${python:Provides}, python-imaging-tk
Breaks: python-imaging-tk (<< 1.1.7+2.0.0-1.1)
Replaces: python-imaging-tk (<< 1.1.7+2.0.0-1.1)
Description: Python Imaging Library - ImageTk Module (Pillow fork)
 Tk dependent python-pil module.

Package: python-pil.imagetk-dbg
Section: debug
Priority: optional
Architecture: any
Multi-Arch: same
Depends: python-pil.imagetk (= ${binary:Version}),
  python-pil-dbg (= ${binary:Version}),
  python-dbg, ${shlibs:Depends}, ${misc:Depends}
Provides: python-imaging-tk-dbg
Breaks: python-imaging-tk-dbg (<< 1.1.7+2.0.0-1.1)
Replaces: python-imaging-tk-dbg (<< 1.1.7+2.0.0-1.1)
Description: Python Imaging Library - ImageTk Module (debug extension)
 Tk dependent python-pil module.
 .
 This package contains the extension built for the Python debug interpreter.

Package: python3-pil
Architecture: any
Multi-Arch: same
Depends: ${python3:Depends}, mime-support | python3-pil.imagetk,
  ${shlibs:Depends}, ${misc:Depends}
Recommends: python3-olefile
Suggests: python-pil-doc, python3-pil-dbg
Provides: ${python:Provides}, python3-pillow
Conflicts: python3-imaging (<< 1.1.7+2.0.0-1.1)
Breaks: python3-imaging (<< 1.1.7+2.0.0-1.1)
Replaces: python3-imaging (<< 1.1.7+2.0.0-1.1)
Description: Python Imaging Library (Python3)
 The Python Imaging Library (PIL) adds an image object to your Python
 interpreter. You can load images from a variety of file formats, and
 apply a rich set of image operations to them.
 .
 Image Objects:
  o Bilevel, greyscale, palette, true colour (RGB), true colour with
    transparency (RGBA).
  o colour separation (CMYK).
  o Copy, cut, paste operations.
  o Flip, transpose, resize, rotate, and arbitrary affine transforms.
  o Transparency operations.
  o Channel and point operations.
  o Colour transforms, including matrix operations.
  o Image enhancement, including convolution filters.
 .
 File Formats:
  o Full (Open/Load/Save): BMP, EPS (with ghostscript), GIF, IM, JPEG,
    MSP, PDF, PNG, PPM, TIFF, XBM.
  o Read only (Open/Load): ARG, CUR, DCX, FLI, FPX, GBR, GD, ICO, IMT, IPTC,
    MCIDAS, MPEG, PhotoCD, PCX, PIXAR, PSD, TGA, SGI, SUN, TGA, WMF, XPM.
  o Save only: PDF, EPS (without ghostscript).

Package: python3-pil-dbg
Section: debug
Priority: optional
Architecture: any
Multi-Arch: same
Depends: python3-pil (= ${binary:Version}), python3-dbg,
  ${shlibs:Depends}, ${misc:Depends}
Breaks: python3-imaging-dbg (<< 1.1.7+2.0.0-1.1)
Replaces: python3-imaging-dbg (<< 1.1.7+2.0.0-1.1)
Description: Python Imaging Library (Python3 debug extension)
 The Python Imaging Library (PIL) adds an image object to your Python
 interpreter. You can load images from a variety of file formats, and
 apply a rich set of image operations to them.
 .
 This package contains the extension built for the Python debug interpreter.

Package: python3-pil.imagetk
Architecture: any
Multi-Arch: same
Depends: python3-pil (= ${binary:Version}),
  python3-tk (>= 3.4.1-2),
  ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}
Suggests: python-pil-doc, python3-pil.imagetk-dbg
Provides: ${python:Provides}
Breaks: python3-imaging-tk (<< 1.1.7+2.0.0-1.1)
Replaces: python3-imaging-tk (<< 1.1.7+2.0.0-1.1)
Description: Python Imaging Library - ImageTk Module (Python3)
 Tk dependent python-pil module.

Package: python3-pil.imagetk-dbg
Section: debug
Priority: optional
Architecture: any
Multi-Arch: same
Depends: python3-pil.imagetk (= ${binary:Version}),
  python3-pil-dbg (= ${binary:Version}),
  python3-dbg, ${shlibs:Depends}, ${misc:Depends}
Breaks: python3-imaging-tk-dbg (<< 1.1.7+2.0.0-1.1)
Replaces: python3-imaging-tk-dbg (<< 1.1.7+2.0.0-1.1)
Description: Python Imaging Library - ImageTk Module (Python3 debug extension)
 Tk dependent python-pil module.
 .
 This package contains the extension built for the Python debug interpreter.

Package: python-pil-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Suggests: python-doc, python3-pil | python-pil, python3-pil.imagetk | python-pil.imagetk
Description: Examples for the Python Imaging Library
 The Python Imaging Library (PIL) adds an image object to your
 Python interpreter. You can load image objects from a variety of file
 formats, and apply a rich set of image operations to them.
 .
 This package contains PIL API documentation and some example scripts.
 You may also want to look at the python-pil-doc-html or
 python-pil-doc-pdf packages for the PIL handbook documentation.

=== debian/tests/control ===
Tests: selftest-py2 selftest-py3
Depends: @

#Tests: upstream-py2 upstream-py3
#Restrictions: allow-stderr
#Depends: @, webp, python-pytest, python3-pytest

## pillow 5.2.0

=== debian/changelog ===
pillow (5.2.0-2) unstable; urgency=medium

  * Apply proposed patch for issue #3227. Closes: #887752.

 -- Matthias Klose <doko@debian.org>  Fri, 20 Jul 2018 14:57:58 +0200

pillow (5.2.0-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Wed, 11 Jul 2018 14:50:06 +0200

## pillow 5.4.1

=== debian/changelog ===
pillow (5.4.1-2+deb10u6) buster-security; urgency=medium

  * Non-maintainer upload by the LTS Team.
  * CVE-2024-28219: buffer overflow in _imagingcms.c

 -- Adrian Bunk <bunk@debian.org>  Wed, 10 Apr 2024 20:46:20 +0300

pillow (5.4.1-2+deb10u5) buster-security; urgency=high

  * Non-maintainer upload by the LTS Security Team.
  * Backport follow-up fix for CVE-2022-22817, upstream commit c930be075.
  * Mark d/rules with .NOTPARALLEL for an implicit -j1.
  * Backport upstream fix for CVE-2021-23437.
  * Backport upstream fix for CVE-2023-44271.

 -- Sean Whitton <spwhitton@spwhitton.name>  Thu, 21 Mar 2024 12:20:25 +0800

pillow (5.4.1-2+deb10u4) buster-security; urgency=high

  * Non-maintainer upload by the Debian LTS team.
  * CVE-2023-50447: Prevent a potential arbitrary code execution vulnerability
    in the PIL.ImageMath.eval functionality. (Closes: #1061172)
  * Re-enable running Pillow's own testsuite in debian/rules.

 -- Chris Lamb <lamby@debian.org>  Mon, 29 Jan 2024 11:10:33 -0800

pillow (5.4.1-2+deb10u3) buster-security; urgency=medium

  * CVE-2022-22815 CVE-2022-22816 CVE-2022-22817

 -- Moritz Mühlenhoff <jmm@debian.org>  Thu, 20 Jan 2022 20:24:28 +0100

pillow (5.4.1-2+deb10u2) buster; urgency=medium

  * CVE-2020-11538 CVE-2020-10378 CVE-2020-10177

 -- Moritz Mühlenhoff <jmm@debian.org>  Wed, 22 Jul 2020 19:23:16 +0200

pillow (5.4.1-2+deb10u1) buster-security; urgency=medium

  * CVE-2019-16865 CVE-2019-19911 CVE-2020-5311 CVE-2020-5312 CVE-2020-5313

 -- Moritz Mühlenhoff <jmm@debian.org>  Thu, 06 Feb 2020 20:47:20 +0100

pillow (5.4.1-2) unstable; urgency=medium

  * Allow for unknown PNG chunks after image data. Closes: #926552.

 -- Matthias Klose <doko@debian.org>  Sun, 07 Apr 2019 02:53:28 +0200

pillow (5.4.1-1) unstable; urgency=medium

  * New upstream version.
  * Enable imagequant support.

 -- Matthias Klose <doko@debian.org>  Fri, 18 Jan 2019 11:05:56 +0100

pillow (5.3.0-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Thu, 18 Oct 2018 12:16:31 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: pillow
 Section: python
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Matthias Klose <doko@debian.org>
+Maintainer: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper (>= 9), tk-dev, dpkg-dev (>= 1.16.1~),
   dh-python,
   python2.7-dev (>= 2.7.8-4),
@@ -14,9 +13,10 @@
   python-olefile, python3-olefile,
   libfreetype6-dev, libjpeg-dev, zlib1g-dev, liblcms2-dev,
   libtiff5-dev | libtiff-dev, libwebp-dev, libraqm-dev,
+  libimagequant-dev, python-nose, python3-nose
 Build-Depends-Indep: python3-sphinx, python3-sphinx-rtd-theme,
 Build-Conflicts: python-cffi, python3-cffi
-Standards-Version: 4.1.4
+Standards-Version: 4.3.0
 Homepage: http://python-pillow.github.io/
 XS-Testsuite: autopkgtest

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

PYVERS	:= $(shell pyversions -vr)
PYVER   := $(shell python -c 'import sys; print sys.version[:3]')

PY3VERS	:= $(shell py3versions -vr)
PY3VER   := $(shell python3 -c 'import sys; print(sys.version[:3])')

include /usr/share/python/python.mk

include /usr/share/dpkg/architecture.mk
ifneq ($(DEB_BUILD_MULTIARCH),$(DEB_HOST_MULTIARCH))
  SET_CROSS_ENV = PYTHONPATH=/usr/lib/python$$pv/plat-$(DEB_HOST_MULTIARCH)

  # FIXME: is this sufficient?
  SET_CROSS_ENV += _PYTHON_HOST_PLATFORM=$(DEB_HOST_GNU_CPU)
endif

build-arch: build
build-indep: build build-doc-stamp
build: build-stamp

build-doc-stamp: build
	PYTHONPATH=$(CURDIR)/$(wildcard build/lib.*-$(PY3VER)) $(MAKE) -C docs html
	touch $@

build-stamp: $(PYVERS:%=build-stamp-python%) $(PY3VERS:%=build-stamp-python%) $(PYVERS:%=check-stamp-python%) $(PY3VERS:%=check-stamp-python%)
	touch $@
build-stamp-python%:
#	tar xvf debian/lcms-images.tar.gz
	$(SET_CROSS_ENV) python$* setup.py build

	$(SET_CROSS_ENV) python$*-dbg setup.py build
	touch $@

pillow_tests = $(wildcard Tests/test*.py)

check-stamp-python%:
ifeq ($(DEB_BUILD_MULTIARCH),$(DEB_HOST_MULTIARCH))
	: # run the tests for the debug interpreter, but continue in case of error
	rm -rf tmp
	mkdir -p tmp
	ln -s ../Tests tmp/Tests
	ln -s ../build tmp/build
ifeq (0,1)
	@echo BEGIN python$*-dbg tests
	-cd tmp && python$*-dbg ../debian/test-built.py --processes=1 --process-timeout=90 $(pillow_tests)
endif
	@echo BEGIN python$* tests
	-cd tmp && python$* ../debian/test-built.py --processes=1 --process-timeout=90 $(pillow_tests)
endif
	touch $@

clean:
	dh_testdir
	dh_testroot
	rm -f *-stamp*
	rm -rf compile build
	rm -rf debian/PILcompat/build
	rm -rf Pillow*.egg-info
	find -name '*.py[co]' -exec rm -f {} \;
	find -type d -name __pycache__ | xargs -r rm -rf
#	rm -f $$(tar tf debian/lcms-images.tar.gz)
	rm -rf tmp
	rm -rf docs/_build
	dh_clean

get-doc:
	wget -r --no-parent --no-host-directories --cut-dirs=2 \
		http://www.pythonware.com/library/pil/handbook/index.htm

install: build install-prereq $(PYVERS:%=install-python%) $(PY3VERS:%=install3-python%)
	dh_installdocs -ppython-pil-doc #Docs/*
	dh_installexamples -ppython-pil-doc

	dh_installdocs -ppython-pil -ppython3-pil README.rst

	: # Replace all '#!' calls to python with /usr/bin/python
	: # and make them executable
	for i in `find debian/python-pil* -mindepth 3 -type f`; do \
	  sed '1s,#!.*python[^ ]*\(.*\),#! /usr/bin/python\1,' \
		$$i > $$i.temp; \
	  if cmp --quiet $$i $$i.temp; then \
	    rm -f $$i.temp; \
	  else \
	    mv -f $$i.temp $$i; \
	    chmod 755 $$i; \
	    echo "fixed interpreter: $$i"; \
	  fi; \
	done
	for i in `find debian/python3-pil* -mindepth 3 -type f`; do \
	  sed '1s,#!.*python[^ ]*\(.*\),#! /usr/bin/python3\1,' \
		$$i > $$i.temp; \
	  if cmp --quiet $$i $$i.temp; then \
	    rm -f $$i.temp; \
	  else \
	    mv -f $$i.temp $$i; \
	    chmod 755 $$i; \
	    echo "fixed interpreter: $$i"; \
	  fi; \
	done

install-prereq:
	dh_testdir
	dh_testroot
	dh_prep

install-python%:
	$(SET_CROSS_ENV) python$* setup.py install --root $(CURDIR)/debian/python-pil \
		$(py_setup_install_args)
	mkdir -p debian/python-pil/usr/include/python$*
	install -o root -g root -m 644 \
		src/libImaging/Imaging.h \
		src/libImaging/ImagingUtils.h \
		src/libImaging/ImPlatform.h \
		src/libImaging/ImDib.h \
		debian/python-pil/usr/include/python$*

	dh_movefiles -ppython-pil.imagetk \
	    --sourcedir=debian/python-pil \
		usr/lib/python$*/$(call py_sitename_sh, $*)/PIL/_imagingtk.so \
		usr/lib/python$*/$(call py_sitename_sh, $*)/PIL/ImageTk.py

	$(SET_CROSS_ENV) python$*-dbg setup.py install \
		--root $(CURDIR)/debian/python-pil-dbg \
		$(py_setup_install_args)
	mkdir -p debian/python-pil-dbg/usr/include/python$*_d
	for i in Imaging.h ImagingUtils.h ImPlatform.h ImDib.h; do \
	  ln -sf ../python$*/$$i \
	    debian/python-pil-dbg/usr/include/python$*_d/$$i; \
	done

	find debian/python-pil*-dbg \
		! -type d ! \( -name '*_d.so' -o -name '*.h' \) | xargs rm -f
	find debian/python-pil*-dbg -depth -empty -exec rmdir {} \;

	dh_movefiles -ppython-pil.imagetk-dbg \
	    --sourcedir=debian/python-pil-dbg \
		usr/lib/python$*/$(call py_sitename_sh, $*)/PIL/_imagingtk_d.so

install3-python%:
	$(SET_CROSS_ENV) python$* setup.py install \
		--root $(CURDIR)/debian/python3-pil \
		$(py_setup_install_args)

	incdir=$$(python$* -c 'import sysconfig; print(sysconfig.get_path("include"))'); \
	mkdir -p debian/python3-pil/$$incdir; \
	install -o root -g root -m 644 \
		src/libImaging/Imaging.h \
		src/libImaging/ImagingUtils.h \
		src/libImaging/ImPlatform.h \
		src/libImaging/ImDib.h \
		debian/python3-pil/$$incdir

	if `python$* -c "import sys; sys.exit(sys.version_info < (3,5))"`; \
	then \
		abitag=.$$(python$* -c "import sysconfig; print(sysconfig.get_config_var('SOABI'))"); \
	else \
		abitag=.$$(python$* -c "import sysconfig; print(sysconfig.get_config_var('SOABI'))")-$(DEB_HOST_MULTIARCH); \
	fi; \
	echo $$abitag; \
	dh_movefiles -ppython3-pil.imagetk \
	    --sourcedir=debian/python3-pil \
		usr/lib/python3/$(call py_sitename_sh, $*)/PIL/_imagingtk$$abitag.so \
		usr/lib/python3/$(call py_sitename_sh, $*)/PIL/ImageTk.py

	$(SET_CROSS_ENV) python$*-dbg setup.py install \
		--root $(CURDIR)/debian/python3-pil-dbg \
		$(py_setup_install_args)

	incname=$$(basename $$(python$* -c 'import sysconfig; print(sysconfig.get_path("include"))')); \
	incddir=$$(python$*-dbg -c 'import sysconfig; print(sysconfig.get_path("include"))'); \
	mkdir -p debian/python3-pil-dbg/$$incddir; \
	for i in Imaging.h ImagingUtils.h ImPlatform.h ImDib.h; do \
	  ln -sf ../$$incname/$$i \
	    debian/python3-pil-dbg/$$incddir/$$i; \
	done

	find debian/python3-pil*-dbg \
		! -type d ! \( -name '*.so' -o -name '*.h' \) | xargs rm -f
	find debian/python3-pil*-dbg -depth -empty -exec rmdir {} \;

	if `python$* -c "import sys; sys.exit(sys.version_info < (3,5))"`; \
	then \
		abitag=.$$(python$*-dbg -c "import sysconfig; print(sysconfig.get_config_var('SOABI'))"); \
	else \
		abitag=.$$(python$*-dbg -c "import sysconfig; print(sysconfig.get_config_var('SOABI'))")-$(DEB_HOST_MULTIARCH); \
	fi; \
	dh_movefiles -ppython3-pil.imagetk-dbg \
	    --sourcedir=debian/python3-pil-dbg \
		usr/lib/python3/$(call py_sitename_sh, $*)/PIL/_imagingtk$$abitag.so

# Build architecture-independent files here.
# Pass -i to all debhelper commands in this target to reduce clutter.
binary-indep: build build-doc-stamp install
	dh_testdir -i
	dh_testroot -i
	dh_installdocs -i
	dh_installdocs -ppython-pil-doc docs/_build/html
	dh_sphinxdoc -ppython-pil-doc
	dh_installexamples -i
	dh_installchangelogs -i CHANGES.rst
	dh_python2 -i
	dh_link -i
	dh_compress -i -X.py
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir -a
	dh_testroot -a
	dh_installdocs -a
	dh_installexamples -a
	dh_installchangelogs -a CHANGES.rst
	for p in \
	  python-pil python-pil.imagetk \
	  python3-pil python3-pil.imagetk; \
	do \
	  rm -rf debian/$$p-dbg/usr/share/doc/$$p-dbg; \
	  ln -s $$p debian/$$p-dbg/usr/share/doc/$$p-dbg; \
	done
	dh_python2 -a
	dh_python3 -a
	dh_strip -ppython-pil --dbg-package=python-pil-dbg
	dh_strip -ppython-pil.imagetk --dbg-package=python-pil.imagetk-dbg
	dh_strip -ppython3-pil --dbg-package=python3-pil-dbg
	dh_strip -ppython3-pil.imagetk --dbg-package=python3-pil.imagetk-dbg
	dh_link -a
	dh_compress -a -X.py
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install
.NOTPARALLEL:

## pillow 5.4.1.6

=== debian/changelog ===
pillow (5.4.1.6-1+dde) unstable; urgency=medium

  * CVE-2022-22815 CVE-2022-22816 CVE-2022-22817

 -- lishengyu <lishengyu@uniontech.com>  Mon, 14 Mar 2022 10:26:46 +0800

pillow (5.4.1.5-1+security) unstable; urgency=medium

  * fix CVE-2021-23437

 -- lishengyu <lishengyu@uniontech.com>  Mon, 13 Sep 2021 08:29:21 +0800

pillow (5.4.1.4-1+security) unstable; urgency=medium

  * fix: CVE-2021-34552

 -- Hu Feng <hufeng@uniontech.com>  Mon, 19 Jul 2021 17:15:53 +0800

pillow (5.4.1.3-1+security) unstable; urgency=medium

  * fix: CVE-2021-25290
  * fix: CVE-2021-25292
  * fix: CVE-2021-25293
  * fix: CVE-2020-35653
  * fix: CVE-2020-35655
  * fix: CVE-2021-25287
  * fix: CVE-2021-25288
  * fix: CVE-2021-28675
  * fix: CVE-2021-28677
  * fix: CVE-2021-28678

 -- Hu Feng <hufeng@uniontech.com>  Fri, 04 Jun 2021 16:07:01 +0800

pillow (5.4.1.2-1+security) unstable; urgency=medium

  * fix: CVE-2021-27921
  * fix: CVE-2021-27922
  * fix: CVE-2021-27923

 -- Hu Feng <hufeng@uniontech.com>  Wed, 31 Mar 2021 11:23:41 +0800

pillow (5.4.1.1-1+dde) buster; urgency=medium

  * Non-maintainer upload.
  * fix CVE-2020-10994

 -- zhouzilong <zhouzilong@uniontech.com>  Thu, 10 Sep 2020 15:44:10 +0800

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,7 @@
   python-olefile, python3-olefile,
   libfreetype6-dev, libjpeg-dev, zlib1g-dev, liblcms2-dev,
   libtiff5-dev | libtiff-dev, libwebp-dev, libraqm-dev,
-  libimagequant-dev, python-nose, python3-nose
+  libimagequant-dev,
 Build-Depends-Indep: python3-sphinx, python3-sphinx-rtd-theme,
 Build-Conflicts: python-cffi, python3-cffi
 Standards-Version: 4.3.0

## pillow 6.1.0

=== debian/changelog ===
pillow (6.1.0-1ubuntu0.2) eoan-security; urgency=medium

  * SECURITY UPDATE: Exceed memory amount and delay in process image
    - debian/patches/CVE-2019-16865-*.patch: Corrected negative seeks in
      PIL/PsdImagePlugin.py, Added decompression bomb checks in
      PIL/GifImagePlugin.py and PIL/IcoImagePlugin.py, Catch buffer overruns
      in libImaging/PcxDecode.c, libImaging/FliDecode.c and added some tests
      in Tests/images/*.
    - CVE-2019-16865
  * SECURITY UPDATE: Denial of service
    - debian/patches/CVE-2019-19911.patch:  Raise an error for an invalid
      number of bands in FPX image in PIL/FpxImagePlugin.py and added some
      testes in Test/images/*.
    - CVE-2019-19911
  * SECURITY UPDATE: Integer overflow
    - debian/patches/CVE-2020-5310.patch: Overflow checks for realloc for tiff
      decoding in src/libImaging/TiffDecode.c and added tests in Test/images/*.
    - CVE-2020-5310
  * SECURITY UPDATE: Buffer overflow
    - debian/patches/CVE-2020-5311.patch: catch SGI buffer overruns
      in src/libImaging/SgiRleDecode.c.
    - CVE-2020-5311
  * SECURITY UPDATE: Buffer overflow
    - debian/patches/CVE-2020-5312.patch: Catch PCX P mode buffer overrun
      in libImaging/PcxDecode.c and added some tests in Test/images/*.
    - CVE-2020-5312
  * SECURITY UPDATE: Buffer overflow
    - debian/patches/CVE-2020-5313.patch: catch FLI buffer overrun in
      libImaging/FliDecode.c and added some tests in Test/images/*.
    - CVE-2020-5313

 -- Leonidas S. Barbosa <leo.barbosa@canonical.com>  Mon, 03 Feb 2020 14:50:52 -0300

pillow (6.1.0-1) unstable; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Sun, 07 Jul 2019 14:36:49 +0200

pillow (6.0.0-1) experimental; urgency=medium

  * New upstream version.

 -- Matthias Klose <doko@debian.org>  Sun, 07 Apr 2019 02:43:30 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: pillow
 Section: python
 Priority: optional
-Maintainer: Matthias Klose <doko@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper (>= 9), tk-dev, dpkg-dev (>= 1.16.1~),
   dh-python,
   python2.7-dev (>= 2.7.8-4),

## pillow 6.2.1

=== debian/changelog ===
pillow (6.2.1-2) unstable; urgency=medium

  * Call python2 in the autopkg python2 tests.

 -- Matthias Klose <doko@debian.org>  Mon, 04 Nov 2019 08:41:21 +0100

pillow (6.2.1-1) unstable; urgency=medium

  * New upstream version, "last Pillow release to support Python 2.7".
  * Replaces python-dbg debpendencies with python2-dbg.
  * Remove Python2 suggests.

 -- Matthias Klose <doko@debian.org>  Sat, 26 Oct 2019 16:49:09 +0200

pillow (6.2.0-1) unstable; urgency=medium

  * New upstream version, last version supporting Python2.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Wed, 16 Oct 2019 15:47:42 +0200

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,9 @@
 Source: pillow
 Section: python
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Matthias Klose <doko@debian.org>
+Maintainer: Matthias Klose <doko@debian.org>
 Build-Depends: debhelper (>= 9), tk-dev, dpkg-dev (>= 1.16.1~),
   dh-python,
-  python2.7-dev (>= 2.7.8-4),
   python-all-dev, python-all-dbg, python-setuptools,
   python3-all-dev, python3-all-dbg, python3-setuptools,
   python-tk, python-tk-dbg,
@@ -17,7 +15,7 @@
   libimagequant-dev,
 Build-Depends-Indep: python3-sphinx, python3-sphinx-rtd-theme,
 Build-Conflicts: python-cffi, python3-cffi
-Standards-Version: 4.3.0
+Standards-Version: 4.4.1
 Homepage: http://python-pillow.github.io/
 XS-Testsuite: autopkgtest
 
@@ -61,7 +59,7 @@
 Priority: optional
 Architecture: any
 Multi-Arch: same
-Depends: python-pil (= ${binary:Version}), python-dbg,
+Depends: python-pil (= ${binary:Version}), python2-dbg,
   ${shlibs:Depends}, ${misc:Depends}
 Provides: python-imaging-dbg
 Breaks: python-imaging-dbg (<< 1.1.7+2.0.0-1.1)
@@ -92,7 +90,7 @@
 Multi-Arch: same
 Depends: python-pil.imagetk (= ${binary:Version}),
   python-pil-dbg (= ${binary:Version}),
-  python-dbg, ${shlibs:Depends}, ${misc:Depends}
+  python2-dbg, ${shlibs:Depends}, ${misc:Depends}
 Provides: python-imaging-tk-dbg
 Breaks: python-imaging-tk-dbg (<< 1.1.7+2.0.0-1.1)
 Replaces: python-imaging-tk-dbg (<< 1.1.7+2.0.0-1.1)
@@ -184,7 +182,7 @@
 Architecture: all
 Multi-Arch: foreign
 Depends: ${misc:Depends}, ${sphinxdoc:Depends}
-Suggests: python-doc, python3-pil | python-pil, python3-pil.imagetk | python-pil.imagetk
+Suggests: python3-doc, python3-pil, python3-pil.imagetk
 Description: Examples for the Python Imaging Library
  The Python Imaging Library (PIL) adds an image object to your
  Python interpreter. You can load image objects from a variety of file

=== debian/rules ===
--- 
+++ 
@@ -19,17 +19,21 @@
   SET_CROSS_ENV += _PYTHON_HOST_PLATFORM=$(DEB_HOST_GNU_CPU)
 endif
 
+build-arch: BBB=bbb
+build-indep: III=iii
 build-arch: build
 build-indep: build build-doc-stamp
 build: build-stamp
 
 build-doc-stamp: build
+	echo XXXXXXXXXXXX BBB=$(BBB) / III=$(III)
 	PYTHONPATH=$(CURDIR)/$(wildcard build/lib.*-$(PY3VER)) $(MAKE) -C docs html
 	touch $@
 
 build-stamp: $(PYVERS:%=build-stamp-python%) $(PY3VERS:%=build-stamp-python%) $(PYVERS:%=check-stamp-python%) $(PY3VERS:%=check-stamp-python%)
 	touch $@
 build-stamp-python%:
+	echo XXXXXXXXXXXX BBB=$(BBB) / III=$(III)
 #	tar xvf debian/lcms-images.tar.gz
 	$(SET_CROSS_ENV) python$* setup.py build
 
@@ -39,6 +43,7 @@
 pillow_tests = $(wildcard Tests/test*.py)
 
 check-stamp-python%:
+ifeq (0,1)
 ifeq ($(DEB_BUILD_MULTIARCH),$(DEB_HOST_MULTIARCH))
 	: # run the tests for the debug interpreter, but continue in case of error
 	rm -rf tmp
@@ -51,6 +56,7 @@
 endif
 	@echo BEGIN python$* tests
 	-cd tmp && python$* ../debian/test-built.py --processes=1 --process-timeout=90 $(pillow_tests)
+endif
 endif
 	touch $@
 
@@ -196,6 +202,7 @@
 # Build architecture-independent files here.
 # Pass -i to all debhelper commands in this target to reduce clutter.
 binary-indep: build build-doc-stamp install
+	echo XXXXXXXXXXXX BBB=$(BBB) / III=$(III)
 	dh_testdir -i
 	dh_testroot -i
 	dh_installdocs -i
@@ -214,6 +221,7 @@
 
 # Build architecture-dependent files here.
 binary-arch: build install
+	echo XXXXXXXXXXXX BBB=$(BBB) / III=$(III)
 	dh_testdir -a
 	dh_testroot -a
 	dh_installdocs -a
@@ -243,4 +251,3 @@
 
 binary: binary-indep binary-arch
 .PHONY: build clean binary-indep binary-arch binary install
-.NOTPARALLEL:
